This service will be undergoing maintenance at 00:00 UTC, 2017-10-23 It is expected to last about 30 minutes
Bug 800143 - Bug found in python-cups-1.9.60-1.fc17 using gcc-with-cpychecker static analyzer
Bug found in python-cups-1.9.60-1.fc17 using gcc-with-cpychecker static analyzer
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: python-cups (Show other bugs)
rawhide
Unspecified Unspecified
unspecified Severity unspecified
: ---
: ---
Assigned To: Tim Waugh
Fedora Extras Quality Assurance
http://fedorapeople.org/~dmalcolm/gcc...
:
Depends On:
Blocks: cpychecker
  Show dependency treegraph
 
Reported: 2012-03-05 15:15 EST by Dave Malcolm
Modified: 2012-03-13 14:34 EDT (History)
2 users (show)

See Also:
Fixed In Version: python-cups-1.9.61-1.fc17
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2012-03-13 14:34:40 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Dave Malcolm 2012-03-05 15:15:44 EST
Description of problem:
I've been writing an experimental static analysis tool to detect bugs commonly occurring within C Python extension modules:
  https://fedorahosted.org/gcc-python-plugin/
  http://gcc-python-plugin.readthedocs.org/en/latest/cpychecker.html
  http://fedoraproject.org/wiki/Features/StaticAnalysisOfPythonRefcounts

I ran the latest version of the tool (in git master; post 0.9) on
python-cups-1.9.60-1.fc17.src.rpm, and it reports various errors.

You can see a list of errors here, triaged into categories (from most significant to least significant):
http://fedorapeople.org/~dmalcolm/gcc-python-plugin/2012-03-05/python-cups-1.9.60-1.fc17/

I've manually reviewed the issue reported by the tool.

Within the category "Reference count too low" the 1 issue reported:
cupsmodule.c:cups_require:ob_refcnt of return value is 1 too low
appears to be a genuine problem: the:
   return Py_None;
should be a
   Py_RETURN_NONE;
otherwise every call to cups_require() will leak a reference to the Py_None singleton.

There may of course be other bugs in my checker tool.

Hope this is helpful; let me know if you need help reading the logs that the tool generates - I know that it could use some improvement.

Version-Release number of selected component (if applicable):
python-cups-1.9.60-1.fc17
gcc-python-plugin post-0.9 git 11462291a66c8db693c8884cb84b795bb5988ffb running the checker in an *f16* chroot
Comment 1 Fedora Update System 2012-03-06 07:00:17 EST
python-cups-1.9.61-1.fc17 has been submitted as an update for Fedora 17.
https://admin.fedoraproject.org/updates/python-cups-1.9.61-1.fc17
Comment 2 Fedora Update System 2012-03-07 02:21:55 EST
Package python-cups-1.9.61-1.fc17:
* should fix your issue,
* was pushed to the Fedora 17 testing repository,
* should be available at your local mirror within two days.
Update it with:
# su -c 'yum update --enablerepo=updates-testing python-cups-1.9.61-1.fc17'
as soon as you are able to.
Please go to the following url:
https://admin.fedoraproject.org/updates/FEDORA-2012-3176/python-cups-1.9.61-1.fc17
then log in and leave karma (feedback).
Comment 3 Fedora Update System 2012-03-13 14:34:40 EDT
python-cups-1.9.61-1.fc17 has been pushed to the Fedora 17 stable repository.  If problems still persist, please make note of it in this bug report.

Note You need to log in before you can comment on or make changes to this bug.